###############
# 解説1
###############
import ctypes 
import tisgrabber as tis
import keyboard
import cv2
import numpy

#tisgrabber_x64.dllをインポートする
ic = ctypes.cdll.LoadLibrary("./tisgrabber_x64.dll")
tis.declareFunctions(ic)


#ICImagingControlクラスライブラリを初期化します。
#この関数は、このライブラリの他の関数が呼び出される前に1回だけ呼び出す必要があります。
ic.IC_InitLibrary(0)

#########
# 解説2
#########
#ダイアログ画面を表示
hGrabber = tis.openDevice(ic)

#########
# 解説3
#########
##### 解説3-1
#デバイスが有効か確認
if(ic.IC_IsDevValid(hGrabber)):
    #ライブスタート開始　引数：0の時非表示、引数：1の時表示
    #ライブ画面は非表示にしています。
    ic.IC_StartLive(hGrabber, 0)
    ##### 解説3-2
    while keyboard.is_pressed("escape") == False:
        ##### 解説3-3
        if ic.IC_SnapImage(hGrabber, 2000) == tis.IC_SUCCESS:
            # 画像記述の変数を宣言する
            Width = ctypes.c_long()
            Height = ctypes.c_long()
            BitsPerPixel = ctypes.c_int()
            colorformat = ctypes.c_int()

            # 画像の説明の値を取得する
            ic.IC_GetImageDescription(hGrabber, Width, Height,
                                        BitsPerPixel, colorformat)
            ##### 解説3-4
            # バッファサイズを計算
            bpp = int(BitsPerPixel.value / 8.0)
            buffer_size = Width.value * Height.value * bpp


            # イメージデータを取得する
            imagePtr = ic.IC_GetImagePtr(hGrabber)

            imagedata = ctypes.cast(imagePtr,
                                    ctypes.POINTER(ctypes.c_ubyte *
                                                    buffer_size))
            #### 解説3-5
            # numpyの配列を作成する
            image = numpy.ndarray(buffer=imagedata.contents,
                                dtype=numpy.uint8,
                                shape=(Height.value,
                                        Width.value,
                                        bpp))
            #### 解説3-6
            image = cv2.flip(image, 0) #画像反転

            #表示を縮小
            resized_img = cv2.resize(image,(640, 480)) 
            cv2.imshow('Window', resized_img) #表示
            cv2.waitKey(10)
        
            #### 解説3-7
            if keyboard.is_pressed("enter"):
                im = cv2.imwrite('test.jpg', image, [cv2.IMWRITE_JPEG_QUALITY, 50])
                print("保存しました。")

        #### 解説3-8
        else:
            print("2秒間フレームが送られてきませんでした。")
            
    ic.IC_StopLive(hGrabber)
    print("処理終了")

else:
    ic.IC_MsgBox(tis.T("No device opened"), tis.T("Simple Live Video"))

ic.IC_ReleaseGrabber(hGrabber)
